﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;



namespace CameraFlashDLLTestAP
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void InitBtn_Click(object sender, EventArgs e)
        {
            label1.Text = "status:";
            if (CameraFlashDLL.ALC_Initialization(comboBox1.SelectedIndex) == 0)
            {
                label1.Text = "status:" + " Initialize Success!";

                LedOnBtn.Enabled = true;
                LedOffBtn.Enabled = true;
                UnInitBtn.Enabled = true;
                InitBtn.Enabled = false;
                comboBox1.Enabled = false;
            }
            else
            {
                label1.Text = "status:" + " Initialize Fail!";

                LedOnBtn.Enabled = false;
                LedOffBtn.Enabled = false;
                UnInitBtn.Enabled = false;
                InitBtn.Enabled = true;
                comboBox1.Enabled = true;
            }
            
        }

        private void UnInitBtn_Click(object sender, EventArgs e)
        {
            label1.Text = "status:";

            if (CameraFlashDLL.ALC_UnInitialization()==0)
            {
                label1.Text = "status:" + " UnInitialize Success!";
         
                LedOnBtn.Enabled = false;
                LedOffBtn.Enabled = false;
                UnInitBtn.Enabled = false;
                InitBtn.Enabled = true;
                comboBox1.Enabled = true;
            }
            else
            {
                label1.Text = "status:" + " UnInitialize Fail!";
            
                LedOnBtn.Enabled = false;
                LedOffBtn.Enabled = false;
                UnInitBtn.Enabled = false;
                InitBtn.Enabled = true;
                comboBox1.Enabled = true;
            }
        }

        private void LedOnBtn_Click(object sender, EventArgs e)
        {
            if (!CameraFlashDLL.Flash(1))
            {
                label1.Text = "status:" + " Led On Fail!";
         
                LedOnBtn.Enabled = false;
                LedOffBtn.Enabled = false;
                UnInitBtn.Enabled = false;
                InitBtn.Enabled = true;
            }

        }

        private void LedOffBtn_Click(object sender, EventArgs e)
        {
            if (!CameraFlashDLL.Flash(0))
            {
                label1.Text = "status:" + " Led On Fail!";
           
                LedOnBtn.Enabled = false;
                LedOffBtn.Enabled = false;
                UnInitBtn.Enabled = false;
                InitBtn.Enabled = true;
            }

        }

        private void Form1_Load(object sender, EventArgs e)
        {
            this.Text = Assembly.GetExecutingAssembly().GetName().Name.ToString() + " " + "V" + Assembly.GetExecutingAssembly().GetName().Version.ToString();

            string[] ClassList = CameraFlashDLL.GetDeviceList();

            foreach (string s in ClassList)
            {
                comboBox1.Items.Add(s.ToUpper());
            }

            if (comboBox1.Items.Count >= 1)
                comboBox1.SelectedIndex = 0;
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {
                case HardwareHelperLib.Native.WM_DEVICECHANGE:
                    {
                        if (m.WParam.ToInt32() == HardwareHelperLib.Native.DBT_DEVNODES_CHANGED)
                        {
                            CameraFlashDLL.ALC_UnInitialization();
                            label1.Text = "status:";
                 
                            LedOnBtn.Enabled = false;
                            LedOffBtn.Enabled = false;
                            UnInitBtn.Enabled = false;
                            InitBtn.Enabled = true;
                            comboBox1.Enabled = true;

                            comboBox1.Items.Clear();
                            string[] ClassList = CameraFlashDLL.GetDeviceList();

                            foreach (string s in ClassList)
                            {
                                comboBox1.Items.Add(s.ToUpper());
                            }

                            if (comboBox1.Items.Count >= 1)
                                comboBox1.SelectedIndex = 0;
                            else
                                comboBox1.Text = "";
                        }
                        break;
                    }
            }
            base.WndProc(ref m);
        }

        private void comboBox1_SelectedIndexChanged(object sender, EventArgs e)
        {
            if (comboBox1.Text.Contains("VID_064E&PID_998D") || comboBox1.Text.Contains("VID_1BCF&PID_2CAA"))
                label2.Visible = true;
            else
                label2.Visible = false;

            
        }
    }
}