using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Text;
using System.Data;
using System.Drawing;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Threading;
using System.Reflection;
using System.Management;

namespace ECcomm
{
    public partial class EC : Form
    {

        #region Winmate WinIO DLL Declare

        [DllImport(@"WMIO2.dll")]
        public static extern bool ModeOpen(uint uiMode);

        [DllImport(@"WMIO2.dll")]
        public static extern bool ModeClose();

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetDevice(byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetDevice(out byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetDevice2(byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetDevice2(out byte uiValue);

        [DllImport(@"WMIO2.dll")]
        public static extern bool GetSMBIOSInfo(string name, byte[] data);

        [DllImport(@"WINDLLEX.dll")]
        private static extern bool SetPortValExV(ushort wPortAddr, uint dwPortVal, byte bSize);

        [DllImport(@"WINDLLEX.dll")]
        private static extern bool GetPortValExV(ushort wPortAddr, out uint pdwPortVal, byte bSize);

        [DllImport(@"WMIO2.dll")]
        public static extern bool SetLightSensorOnOff(uint uiValue);

        #endregion

        private Thread threadHotTabHook;
        private FormHotTabHook formHotTabHook;

        //EC KeySpace
        private const uint KBC_HIF2_DATA = 0x68; //0x62  0x68
        private const uint KBC_HIF2_CMD = 0x6C; //0x66  0x6C
        private const uint WEC_CMD = 0x81;
        private const uint REC_CMD = 0x80;

        public enum ECBufferEvent : int
        {
            ECBufferEvent_WaitInputBufferEmpty = 0,
            ECBufferEvent_WaitOutputBufferFull,
            ECBufferEvent_CleanOutputBuffer
        }

        public EC()
        {
            InitializeComponent();
        }

        private void InitializeHook()
        {
            threadHotTabHook = new Thread(InitializeHotTabHook);
            threadHotTabHook.Start();
        }
        private void InitializeHotTabHook()
        {
            try
            {
                formHotTabHook = new FormHotTabHook(true);
                formHotTabHook.ShowInTaskbar = false;
                formHotTabHook.Visible = false;
                formHotTabHook.Opacity = 0;
                Application.Run(formHotTabHook);
            }
            catch
            {
                //MessageBox.Show("Can't Open UserActivityHook");
            }

        }

        private void btnConsumerModeKBC_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            listBox2.Items.Clear();
            ModeOpen(2);
            string strOK = "Consumer Mode KBC";
            listBox1.Items.Add(strOK);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void btnStandardModeKBC_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            listBox2.Items.Clear();
            ModeClose();
            string strOK = "Standard Mode KBC";
            listBox1.Items.Add(strOK);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void btnClear_Click(object sender, EventArgs e)
        {
            listBox1.Items.Clear();
            listBox2.Items.Clear();
            textBox1.Clear();
        }

        private void EC_Load(object sender, EventArgs e)
        {
            InitializeHook();
            textBox1.Focus();
            EC_SizeChanged(null, null);
            verLabel.Text = "Ver " + Assembly.GetExecutingAssembly().GetName().Version.ToString();

            SetLightSensorOnOff(1);
        }

        private void btnFocus_Click(object sender, EventArgs e)
        {
            textBox1.Focus();
        }

        private void textBox1_KeyPress(object sender, KeyPressEventArgs e)
        {
            int ch;
            ch = Convert.ToInt32(e.KeyChar);
            string strkey = "Pressed:   (0x" + ch.ToString("X2") + ")";

            listBox1.Items.Add(strkey);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void textBox1_KeyUp(object sender, KeyEventArgs e)
        {
            string strkey = "UP   : " + Convert.ToString(e.KeyCode).ToString();
            strkey = strkey + "      ; (" + e.KeyValue.ToString("X2") + ")";

            listBox1.Items.Add(strkey);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            string strkey = "Down : " + Convert.ToString(e.KeyCode).ToString();
            strkey = strkey + " ; (" + e.KeyValue.ToString("X2") + ")";

            listBox1.Items.Add(strkey);
            listBox1.SelectedIndex = (listBox1.Items.Count - 1);
        }

        private void DevSetBtn_Click(object sender, EventArgs e)
        {
            SetDevice();
        }

        private void DevGetBtn_Click(object sender, EventArgs e)
        {
            GetDevice();
        }


        private void tabPage3_Click(object sender, EventArgs e)
        {
            GetDevice();
        }

        private void tabPage3_Enter(object sender, EventArgs e)
        {
            GetDevice();
        }

        private void GetDevice()
        {
            bool ret;
            byte Value;

            ret = GetDevice(out Value);
            if (!ret)
                MessageBox.Show("GetDevice1 Error");
            else
            {
                if ((Value & 0x80) == 0x80)
                    DevBit7Chk.Checked = true;
                else
                    DevBit7Chk.Checked = false;

                if ((Value & 0x40) == 0x40)
                    DevBit6Chk.Checked = true;
                else
                    DevBit6Chk.Checked = false;

                if ((Value & 0x20) == 0x20)
                    DevBit5Chk.Checked = true;
                else
                    DevBit5Chk.Checked = false;

                if ((Value & 0x10) == 0x10)
                    DevBit4Chk.Checked = true;
                else
                    DevBit4Chk.Checked = false;

                if ((Value & 0x08) == 0x08)
                    DevBit3Chk.Checked = true;
                else
                    DevBit3Chk.Checked = false;

                if ((Value & 0x04) == 0x04)
                    DevBit2Chk.Checked = true;
                else
                    DevBit2Chk.Checked = false;

                if ((Value & 0x02) == 0x02)
                    DevBit1Chk.Checked = true;
                else
                    DevBit1Chk.Checked = false;

                if ((Value & 0x01) == 0x01)
                    DevBit0Chk.Checked = true;
                else
                    DevBit0Chk.Checked = false;
            }
        }

        private void SetDevice()
        {
            byte setvalue = 0;
            bool ret;


            if (DevBit0Chk.Checked)
                setvalue += 0x01;

            if (DevBit1Chk.Checked)
                setvalue += 0x02;

            if (DevBit2Chk.Checked)
                setvalue += 0x04;

            if (DevBit3Chk.Checked)
                setvalue += 0x08;

            if (DevBit4Chk.Checked)
                setvalue += 0x10;

            if (DevBit5Chk.Checked)
                setvalue += 0x20;

            if (DevBit6Chk.Checked)
                setvalue += 0x40;

            if (DevBit7Chk.Checked)
                setvalue += 0x80;


            ret = SetDevice(setvalue);
            if (!ret)
            {
                GetDevice();
                MessageBox.Show("SetDevice1 Error");
            }
        }


        private void GetDevice2()
        {
            bool ret;
            byte Value;

            ret = GetDevice2(out Value);
            if (!ret)
                MessageBox.Show("GetDevice2 Error");
            else
            {
                if ((Value & 0x80) == 0x80)
                    Dev2Bit7Chk.Checked = true;
                else
                    Dev2Bit7Chk.Checked = false;

                if ((Value & 0x40) == 0x40)
                    Dev2Bit6Chk.Checked = true;
                else
                    Dev2Bit6Chk.Checked = false;

                if ((Value & 0x20) == 0x20)
                    Dev2Bit5Chk.Checked = true;
                else
                    Dev2Bit5Chk.Checked = false;

                if ((Value & 0x10) == 0x10)
                    Dev2Bit4Chk.Checked = true;
                else
                    Dev2Bit4Chk.Checked = false;

                if ((Value & 0x08) == 0x08)
                    Dev2Bit3Chk.Checked = true;
                else
                    Dev2Bit3Chk.Checked = false;

                if ((Value & 0x04) == 0x04)
                    Dev2Bit2Chk.Checked = true;
                else
                    Dev2Bit2Chk.Checked = false;

                if ((Value & 0x02) == 0x02)
                    Dev2Bit1Chk.Checked = true;
                else
                    Dev2Bit1Chk.Checked = false;

                if ((Value & 0x01) == 0x01)
                    Dev2Bit0Chk.Checked = true;
                else
                    Dev2Bit0Chk.Checked = false;
            }
        }

        private void SetDevice2()
        {
            byte setvalue = 0;
            bool ret;


            if (Dev2Bit0Chk.Checked)
                setvalue += 0x01;

            if (Dev2Bit1Chk.Checked)
                setvalue += 0x02;

            if (Dev2Bit2Chk.Checked)
                setvalue += 0x04;

            if (Dev2Bit3Chk.Checked)
                setvalue += 0x08;

            if (Dev2Bit4Chk.Checked)
                setvalue += 0x10;

            if (Dev2Bit5Chk.Checked)
                setvalue += 0x20;

            if (Dev2Bit6Chk.Checked)
                setvalue += 0x40;

            if (Dev2Bit7Chk.Checked)
                setvalue += 0x80;


            ret = SetDevice2(setvalue);
            if (!ret)
            {
                GetDevice2();
                MessageBox.Show("SetDevice2 Error");
            }
        }


        private int GetByteLen(byte[] array)
        {
            int i = 0;
            int len = 0;

            for (i = 0; i < array.Length; i++)
            {
                if (array[i] == 0)
                    return len;
                else
                    len++;

            }

            return len;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            string ss = "";
            byte[] value = new byte[128];

            if (GetSMBIOSInfo("/IV", value))
                ss += "/IV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/ID", value))
                ss += "/ID = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SM", value))
                ss += "/SM = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SP", value))
                ss += "/SP = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SV", value))
                ss += "/SV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SS", value))
                ss += "/SS = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SU", value))
                ss += "/SU = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SK", value))
                ss += "/SK = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/SF", value))
                ss += "/SF = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BM", value))
                ss += "/BM = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BP", value))
                ss += "/BP = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BV", value))
                ss += "/BV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BS", value))
                ss += "/BS = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/BT", value))
                ss += "/BT = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CM", value))
                ss += "/CM = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CT", value))
                ss += "/CT = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CV", value))
                ss += "/CV = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CS", value))
                ss += "/CS = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CA", value))
                ss += "/CA = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            if (GetSMBIOSInfo("/CO", value))
                ss += "/CO = " + System.Text.ASCIIEncoding.ASCII.GetString(value, 0, GetByteLen(value)) + "\r\n";

            MessageBox.Show(ss, "SMBios Information");
        }

        private void Dev2SetBtn_Click(object sender, EventArgs e)
        {
            SetDevice2();
        }

        private void Dev2GetBtn_Click(object sender, EventArgs e)
        {
            GetDevice2();
        }

        private void tabPage5_Click(object sender, EventArgs e)
        {
            GetDevice2();
        }

        private void tabPage5_Enter(object sender, EventArgs e)
        {
            GetDevice2();
        }

        protected override void WndProc(ref Message m)
        {
            switch (m.Msg)
            {

                case HotTabECEventArgs.ECEvent_F1Short:
                    listBox2.Items.Add("F1 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F1Long:
                    listBox2.Items.Add("F1 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F2Short:
                    listBox2.Items.Add("F2 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F2Long:
                    listBox2.Items.Add("F2 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F3Short:
                    listBox2.Items.Add("F3 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F3Long:
                    listBox2.Items.Add("F3 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F4Short:
                    listBox2.Items.Add("F4 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F4Long:
                    listBox2.Items.Add("F4 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F5Short:
                    listBox2.Items.Add("F5 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F5Long:
                    listBox2.Items.Add("F5 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F6Short:
                    listBox2.Items.Add("F6 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F6Long:
                    listBox2.Items.Add("F6 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F7Short:
                    listBox2.Items.Add("F7 Key Short Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_F7Long:
                    listBox2.Items.Add("F7 Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_Menu:
                    listBox2.Items.Add("Menu Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_HomeShort:
                    listBox2.Items.Add("Home Key Short Press)");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_HomeLong:
                    listBox2.Items.Add("Home Key Long Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_VolumeUp:
                    listBox2.Items.Add("Volume UP(Up) Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_VolumeDown:
                    listBox2.Items.Add("Volume Down(Down) Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_Left:
                    listBox2.Items.Add("Left Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_Right:
                    listBox2.Items.Add("Right Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_OK:
                    listBox2.Items.Add("OK Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_FM08Lamp:
                    listBox2.Items.Add("[FM08]Lamp Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_FM08BrightnessAuto:
                    listBox2.Items.Add("[FM08]Bright Auto Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_FM08BrightnessDown:
                    listBox2.Items.Add("[FM08]Bright Down Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_FM08BrightnessUp:
                    listBox2.Items.Add("[FM08]Bright Up Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_FM08VolumeMute:
                    listBox2.Items.Add("[FM08]Volume Mute Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_FM08VolumeUp:
                    listBox2.Items.Add("[FM08]Volume Up Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_FM08VolumeDown:
                    listBox2.Items.Add("[FM08]Volume Down Key Press");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;

                case HotTabECEventArgs.ECEvent_GroundDockingIn:
                    listBox2.Items.Add("Ground Dock In(only support IBCMC)");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_AirDockingIn:
                    listBox2.Items.Add("Air Docking In(only support IBCMC)");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_DockingOut:
                    listBox2.Items.Add("Docking AC Out(only support IBCMC)");
                    listBox2.SelectedIndex = (listBox2.Items.Count - 1);
                    break;
                case HotTabECEventArgs.ECEvent_LightSensorEvent:
                    LightSensorTriggerEvent();
                    break;
            }

            base.WndProc(ref m);
        }

        private void EC_FormClosing(object sender, FormClosingEventArgs e)
        {
            formHotTabHook.Stop();
            Environment.Exit(1);
        }

        private void EC_SizeChanged(object sender, EventArgs e)
        {
            listBox2.Width = this.Width - (listBox1.Right + 40);

            listBox1.Height = groupBox1.Height - 120;
            listBox2.Height = groupBox1.Height - 120;

            listBox1.Width = (groupBox1.Width - 30) / 2;
            listBox2.Width = listBox1.Width;
            listBox2.Left = listBox1.Right + 10;
        }

        public bool WinIO_ReadFromECSpace(uint bAddress, out uint bValue)
        {
            bool WinIoOK1;
            uint uiAddress = bAddress;
            uint uiValue = 0;

            bValue = uiValue;
            WinIoOK1 = false;

                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_CleanOutputBuffer) == false)
                    {//Initial : Clean Output Buffer
                        Thread.Sleep(10);
                    }
                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_WaitInputBufferEmpty) == false)
                    {//Initial : Wait For Input Buffer Empty
                        Thread.Sleep(10);
                    }


                    while (SetPortValExV((ushort)KBC_HIF2_CMD, REC_CMD, 1) == false)
                    {//Set Command REC_CMD : Set Command 
                        Thread.Sleep(10);
                    }
                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_WaitInputBufferEmpty) == false)
                    {//Set Command REC_CMD : Wait For Input Buffer Empty
                        Thread.Sleep(10);
                    }
                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_CleanOutputBuffer) == false)
                    {//Set Command REC_CMD : Clean Output Buffer
                        Thread.Sleep(10);
                    }


                    while (SetPortValExV((ushort)KBC_HIF2_DATA, uiAddress, 1) == false)
                    {//Set Command Address : Set Command
                        Thread.Sleep(10);
                    }
                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_WaitInputBufferEmpty) == false)
                    {//Set Command Address : Wait For Input Buffer Empty
                        Thread.Sleep(10);
                    }
                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_WaitOutputBufferFull) == false)
                    {//Set Command Address : Wait Output Buffer Full
                        Thread.Sleep(10);
                    }


                    while (GetPortValExV((ushort)KBC_HIF2_DATA, out uiValue, 1) == false)
                    {//Get Data  : Get Data
                        Thread.Sleep(10);
                    }
                    while (WinIO_WaitEC(ECBufferEvent.ECBufferEvent_CleanOutputBuffer) == false)
                    {//Complete : Clean Output Buffer
                        Thread.Sleep(10);
                    }

            bValue = uiValue;

            return WinIoOK1;
        }


        public bool WinIO_WriteToECSpace(uint bAddress, uint bValue)
        {
            uint uiAddress = bAddress;
            uint uiValue = bValue;

            int count;
            bool WinIoOK1;

            count = -1;
            WinIoOK1 = false;

                    do
                    {
                        WinIoOK1 = SetPortValExV((ushort)KBC_HIF2_CMD, WEC_CMD, 1);
                        Thread.Sleep(40);
                        count += 1;
                    }
                    while (WinIoOK1 == false && count < 10);
                    if (WinIoOK1 == false) return false;

                    count = -1;
                    WinIoOK1 = false;
                    do
                    {
                        WinIoOK1 = SetPortValExV((ushort)KBC_HIF2_DATA, uiAddress, 1);
                        Thread.Sleep(40);
                        count += 1;
                    }
                    while (WinIoOK1 == false && count < 10);
                    if (WinIoOK1 == false) return false;

                    count = -1;
                    WinIoOK1 = false;
                    do
                    {
                        WinIoOK1 = SetPortValExV((ushort)KBC_HIF2_DATA, uiValue, 1);
                        Thread.Sleep(40);
                        count += 1;
                    }
                    while (WinIoOK1 == false && count < 10);

            return WinIoOK1;
        }

        //EC Buffer Event
        public bool WinIO_WaitEC(ECBufferEvent ecEvent)
        {
            uint dwRet = 0;
            uint WaitOutputBufferCount = 0;
            uint WaitInputBufferCount = 0;
            uint CleanOutputBufferCount = 0;

            switch (ecEvent)
            {
                case ECBufferEvent.ECBufferEvent_WaitInputBufferEmpty:
                    do
                    {
                        //Sleep(10);
                        WaitInputBufferCount++;
                        if (WaitInputBufferCount >= 50)
                        {
                            return false;
                        }
                        if (!GetPortValExV((ushort)KBC_HIF2_CMD, out dwRet, 1)) dwRet = 0x02;

                        if ((dwRet & 0x02) > 0)
                            Thread.Sleep(10);
                    }
                    while ((dwRet & 0x02) > 0);
                    break;
                case ECBufferEvent.ECBufferEvent_WaitOutputBufferFull:
                    do
                    {
                        //Sleep(10);
                        WaitOutputBufferCount++;
                        if (WaitOutputBufferCount >= 50)
                        {
                            return false;
                        }
                        if (!GetPortValExV((ushort)KBC_HIF2_CMD, out dwRet, 1)) dwRet = 0x00;

                        if ((dwRet & 0x01) == 0)
                            Thread.Sleep(10);
                    }
                    while ((dwRet & 0x01) == 0);
                    break;
                case ECBufferEvent.ECBufferEvent_CleanOutputBuffer:
                    while (true)
                    {
                        Thread.Sleep(10);
                        CleanOutputBufferCount++;
                        if (CleanOutputBufferCount >= 50)
                        {
                            return false;
                        }
                        if (!GetPortValExV((ushort)KBC_HIF2_CMD, out dwRet, 1)) continue;
                        if ((dwRet & 0x01) == 0) break;
                        GetPortValExV((ushort)KBC_HIF2_DATA, out dwRet, 1);
                    }
                    break;
            }
            return true;
        }


        //Get EC Light Sensor Trigger Event Brightness 0~100
        public bool WinIO_GetEC_LightSensorEvent_Brightness(out uint bValue)
        {
            WinIO_ReadFromECSpace(0x95, out bValue);

            return true;
        }

        public void SetWmiBrightness(byte targetBrightness)
        {
            ManagementScope scope = new ManagementScope("root\\WMI");
            SelectQuery query = new SelectQuery("WmiMonitorBrightnessMethods");
            using (ManagementObjectSearcher searcher = new ManagementObjectSearcher(scope, query))
            {
                using (ManagementObjectCollection objectCollection = searcher.Get())
                {
                    try
                    {
                        foreach (ManagementObject mObj in objectCollection)
                        {
                            mObj.InvokeMethod("WmiSetBrightness", new Object[] { UInt32.MaxValue, targetBrightness });
                            break;
                        }
                    }
                    catch
                    {
                    }
                }
            }
        }

        public void LightSensorTriggerEvent()
        {
            uint iTemp = 0;
            if (WinIO_GetEC_LightSensorEvent_Brightness(out iTemp))
            {
                //bResult = SetSystemBrightness(iTemp);
                iCurrentBrightnessLevelLabel.Text = iTemp.ToString();
                SetWmiBrightness((byte)(iTemp));
            }
        }

        private void checkBoxAutoBrigtness_CheckedChanged(object sender, EventArgs e)
        {
            if (checkBoxAutoBrigtness.Checked)
                SetLightSensorOnOff(1);
            else
                SetLightSensorOnOff(0);
        }
    }
}