﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Runtime.InteropServices;
using System.Diagnostics;

namespace TouchModeSetting
{
    public partial class Form1 : Form
    {
        [DllImport(@"WMTOUCHMODE.dll")]
        public static extern bool GetTouchMode(out byte puiTouch);

        [DllImport(@"WMTOUCHMODE.dll")]
        public static extern bool SetTouchMode(byte uiValue);

        [DllImport(@"WMTOUCHMODE.dll")]
        public static extern bool GetTocuhModelVersion(byte[] model, byte[] version);


        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            TouchModeInit();
        }

        private void radioButton1_CheckedChanged(object sender, EventArgs e)
        {
            if (!SetTouchMode(0))
            {
                MessageBox.Show("Set Hand/Rain Mode Failed!", "Error!");
            }
        }

        private void radioButton2_CheckedChanged(object sender, EventArgs e)
        {
            if (!SetTouchMode(1))
            {
                MessageBox.Show("Set Stylus Mode Failed!", "Error!");
            }
        }

        private void radioButton3_CheckedChanged(object sender, EventArgs e)
        {
            if (!SetTouchMode(2))
            {
                MessageBox.Show("Set Glove Mode Failed!", "Error!");
            }
        }


        private int GetByteLen(byte[] array)
        {
            int i = 0;
            int len = 0;

            for (i = 0; i < array.Length; i++)
            {
                if (array[i] == 0)
                    return len;
                else
                    len++;

            }

            return len;
        }

        private bool TouchModeInit()
        {
            bool bRet = true;

            byte[] model = new byte[128];
            byte[] version = new byte[128];

            if (GetTocuhModelVersion(model, version))
            {
                textBoxModelValue.Text = System.Text.ASCIIEncoding.ASCII.GetString(model, 0, GetByteLen(model));
                textBoxVersionValue.Text = System.Text.ASCIIEncoding.ASCII.GetString(version, 0, GetByteLen(version));
            }
            else
            {
                bRet = false;
                MessageBox.Show("Unsupported Touch Mode Setting!", "Error!");
                Environment.Exit(1);
            }

            byte touch_src;
            if (!GetTouchMode(out touch_src))
            {
                groupBoxTouchMode.Enabled = false;
            }

            if (groupBoxTouchMode.Enabled)
            {
                switch (touch_src)
                {
                    case 0:
                        radioButton1.Checked = true;
                        break;
                    case 1:
                        radioButton2.Checked = true;
                        break;
                    case 2:
                        radioButton3.Checked = true;
                        break;
                    default:
                        bRet = false;
                        //MessageBox.Show("Unsupported Touch Mode Setting!", "Error!");
                        //Environment.Exit(1);
                        break;
                }
            }
            else
            {
                bRet = false;
                //MessageBox.Show("Unsupported Touch Mode Setting!", "Error!");
                //Environment.Exit(1);
            }


            return bRet;
        }

    }
}
