﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.InteropServices;

namespace TouchModeSetting
{
    class User32DLL
    {
        [DllImport("user32.dll")]
        public static extern Int32 FindWindow(String lpClassName, String lpWindowName);

        [DllImport("user32.dll")]
        public static extern Int32 PostMessage(Int32 hWnd, Int32 wMsg, Int32 wParam, Int32 lParam);

        [DllImport("user32.dll")]
        static extern int SetWindowRgn(IntPtr hWnd, IntPtr hRgn, bool bRedraw);

        [DllImport("gdi32.dll")]
        static extern IntPtr CreateRoundRectRgn(int x1, int y1, int x2, int y2, int cx, int cy);

        [DllImport("user32.dll")]
        public static extern void keybd_event(byte bVk, byte bScan, uint dwFlags,
           int dwExtraInfo);

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("user32", EntryPoint = "RegisterWindowMessage")]
        public static extern int RegisterWindowMessage(string lpString);

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("user32", EntryPoint = "SendNotifyMessage")]
        public static extern bool SendNotifyMessage(Int32 hWnd, Int32 Msg, Int32 wParam, Int32 lParam);

        [System.Security.SuppressUnmanagedCodeSecurity]
        [DllImport("user32", EntryPoint = "SendMessage")]
        public static extern int SendMessage(Int32 hWnd, Int32 wMsg, Int32 wParam, Int32 lParam);

        public static void SetWindowRgn(IntPtr hWnd, int width, int height, int cx, int cy)
        {
            SetWindowRgn(hWnd, CreateRoundRectRgn(0, 0, width + 1, height + 1, cx, cy), true);
        }

    }
}
